#include <stdio.h>
#include <bcm2835.h>

#define	Clock	16
#define	Address	20
#define	DataOut	21
#define Cs  22
#define Eoc  27

unsigned int ADC_Read(unsigned char Channel)
{
	unsigned int ConvertValue;
	unsigned char i, Chan;
	unsigned char ConvertValueL, ConvertValueH;
	unsigned char delay;
 
 	ConvertValueL = ConvertValueH = 0; 
 	delay = 0;
	if(bcm2835_gpio_lev(Eoc))
	{
		bcm2835_gpio_write(Clock ,0); 
		bcm2835_gpio_write(Cs ,1); //digitalWrite(Cs,1);    
		delayMicroseconds(10); //delayMicroseconds(20);
		bcm2835_gpio_write(Cs ,0); //digitalWrite(Cs,0);    
		delayMicroseconds(10); //delayMicroseconds(20);
		Channel = Channel << 4;
		for (i = 0; i < 4; i ++) 
		{
			Chan = Channel;
			Chan = Chan >> 7;
			if(Chan)
				bcm2835_gpio_write(Address ,1); //digitalWrite(Address,1);  
			else
				bcm2835_gpio_write(Address ,0); //digitalWrite(Address,0);  
			delayMicroseconds(20);                 
			bcm2835_gpio_write(Clock ,1); //digitalWrite(Clock ,1);
	  		delayMicroseconds(20); 
			bcm2835_gpio_write(Clock ,0); //digitalWrite(Clock ,0);              
			Channel = Channel << 1;
		}
		for (i = 0; i < 6;i ++) 
		{
			bcm2835_gpio_write(Clock ,1); //digitalWrite(Clock ,1);
			delayMicroseconds(20); 
			bcm2835_gpio_write(Clock ,0); //digitalWrite(Clock ,0);
			delayMicroseconds(20);
		}
		bcm2835_gpio_write(Cs,1); //digitalWrite(Cs,1);    

		while ((!bcm2835_gpio_lev(Eoc)) && (delay < 10) )
		{
			delayMicroseconds(100);
			delay ++;
		}
		if (delay == 10)
		{
			return (0xFFFF);
		}
		else
		{
			delayMicroseconds(100);           //Wait10us;
			bcm2835_gpio_write(Clock ,0); //digitalWrite(Clock ,0);            //CLK = 0
			bcm2835_gpio_write(Cs,1); //digitalWrite(Cs,1);                //CS = 1 
			delayMicroseconds(100);               //Wait1us;
			bcm2835_gpio_write(Cs,0); //digitalWrite(Cs,0);                 //CS = 0
			delayMicroseconds(100);              //Wait1us;
			for (i = 0; i < 2; i ++) 
			{
				bcm2835_gpio_write(Clock ,1); //digitalWrite(Clock ,1);        // CLK = 1
				ConvertValueH <<= 1;
				if(bcm2835_gpio_lev(DataOut) )      //DOUT
					ConvertValueH |= 0x1;
				bcm2835_gpio_write(Clock ,0); //digitalWrite(Clock ,0);         //CLK = 0  
				delayMicroseconds(10);           //Wait1us;
			} 
			for (i = 0; i < 8; i ++) 
			{
				bcm2835_gpio_write(Clock ,1); //digitalWrite(Clock ,1);        // CLK = 1
				ConvertValueL <<= 1;
				if(bcm2835_gpio_lev(DataOut))         //DOUT
					ConvertValueL |= 0x1;
				bcm2835_gpio_write(Clock ,0); //digitalWrite(Clock ,0);        // CLK = 0
				delayMicroseconds(10);          //  Wait1us;
			} 
			bcm2835_gpio_write(Cs,1); //digitalWrite(Cs,1);                  //CS = 1
			ConvertValue = ConvertValueH;
			ConvertValue <<= 8;
			ConvertValue |= ConvertValueL;
			return ConvertValue; 
		}
	}

return 0;

}


int main()
{
	if (!bcm2835_init())return 1 ;

	bcm2835_gpio_fsel(DataOut,BCM2835_GPIO_FSEL_INPT);
	bcm2835_gpio_set_pud(DataOut, BCM2835_GPIO_PUD_UP);

	bcm2835_gpio_fsel(Eoc,BCM2835_GPIO_FSEL_INPT);
	bcm2835_gpio_set_pud(Eoc, BCM2835_GPIO_PUD_UP);

	bcm2835_gpio_fsel(Cs,BCM2835_GPIO_FSEL_OUTP);

	bcm2835_gpio_fsel(Clock,BCM2835_GPIO_FSEL_OUTP);
	bcm2835_gpio_fsel(Address,BCM2835_GPIO_FSEL_OUTP);

//	bcm2835_gpio_write(Cs,LOW);

	while(1)
	{
/*  		printf("AD: %d ",ADC_Read(0));//delayMicroseconds(50);//bcm2835_delay(1);
	 	 printf("%d ",ADC_Read(1)); //delayMicroseconds(50); //bcm2835_delay(1);

               printf("%d ",ADC_Read(2));//delayMicroseconds(50); // bcm2835_delay(1);

               printf("%d ",ADC_Read(3));//delayMicroseconds(50);  //bcm2835_delay(1);

               printf("%d ",ADC_Read(4));//delayMicroseconds(50); // bcm2835_delay(1);

               printf("%d ",ADC_Read(5));//delayMicroseconds(50); // bcm2835_delay(1);

               printf("%d ",ADC_Read(6));//delayMicroseconds(50); // bcm2835_delay(1);

               printf("%d ",ADC_Read(7));//delayMicroseconds(50); // bcm2835_delay(1);

               printf("%d ",ADC_Read(8));// delayMicroseconds(50);// bcm2835_delay(1);

               printf("%d ",ADC_Read(9));// delayMicroseconds(50);// bcm2835_delay(1);

               printf("%d\r\n",ADC_Read(10));//delayMicroseconds(50); // bcm2835_delay(1);
*/
               printf("%d \r\n",ADC_Read(6));
              
               bcm2835_delay(10);
  	}
}
